﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Design;


namespace RagPong
{
    class powerUp : Bounceable
    {
        //the active time of the powerup in milliseconds
        public float expirationTime;
        public bool active, claimed;
        public paddle augment;
        public SoundEffect collect;

        //default constructor: sets speed, expirationTime, active to default values
        //initializes shell, all other values null
        public powerUp()
        {
            setDefaultSpeed();
            setDefaultExpirationTime();
            active = true;
            claimed = false;

            shell = new BoundingSphere();

        }

        //this function updates the position of the powerup on the screen and determines
        //whether the powerup has changed directions or collided with a paddle. whether
        //or not the powerup is still valid is returned.  if a player has hit the powerup,
        //then the powerup should no longer be drawn
        public void UpdatePowerUp(GraphicsDeviceManager graphics, player rPlayer, player lPlayer, double elapsed )
        {
            // Move the sprite by speed, scaled by elapsed time.
            shell.Center = new Vector3(shell.Center.X + (speed.X *
                (float)elapsed),
                shell.Center.Y + (speed.Y * (float)elapsed), 0);

            float MaxX =
                graphics.GraphicsDevice.Viewport.Width;
            float MinX = 0;
            float MaxY =
                graphics.GraphicsDevice.Viewport.Height;
            float MinY = 0;

            if (Collision(rPlayer.getPaddle()))
            {
                //the player's powerup is set to the one with which it has collided
                rPlayer.applyNewPowerUp(this);
                //the powerup is no longer valid
                active = false;

                collect.Play();
            }

            else if (Collision(lPlayer.getPaddle()))
            {
                //the player's powerup is set to the one with which it has collided
                lPlayer.applyNewPowerUp(this);
                //the powerup is no longer valid
                active = false;

                collect.Play();
            }

            // Check for bounce.
            else if (getRightBound() > MaxX)
            {
                speed.X *= -1;
                changePosition(new Vector2(MaxX - getRightBound(), 0.0f));

            }

            else if (getLeftBound() < MinX)
            {
                speed.X *= -1;
                changePosition(new Vector2(MinX - getLeftBound(), 0.0f));

            }

            else if (getLowerBound() > MaxY)
            {
                speed.Y *= -1;
                changePosition(new Vector2(0.0f, MaxY - getLowerBound()));

            }

            else if (getUpperBound() < MinY)
            {
                speed.Y *= -1;
                changePosition(new Vector2(0.0f, MinY - getUpperBound()));

            }

        }

        public void setDefaultExpirationTime()
        {
            expirationTime = 15000f;
        }
        
        public override void setDefaultSpeed()
        {
            speed = new Vector2(400f, 400f);
        }

        public override void draw(SpriteBatch sB)
        {
            if(active)
                base.draw(sB);
        }

    }
}